Contributing to IoTeX Core
============================

The IoTeX Core project operates an open contributor model where anyone is welcome to contribute towards development in the form of peer review, testing and patches. This document explains the practical process and guidelines for contributing.

Contributor Workflow
--------------------

The codebase is maintained using the "contributor workflow" where everyone
without exception contributes patch proposals using "pull requests". This
facilitates social contribution, easy testing and peer review.

To contribute a patch, the workflow is as follows:

  1. Fork repository
  1. Create topic branch
  1. Commit patches

In general commits should be atomic and diffs should be easy to read, and the [coding conventions](https://github.com/golang/go/wiki/CodeReviewComments)
must be adhered to.


Copyright
---------

By contributing to this repository, you agree to license your work under the 
Apache 2.0 license. Any work contributed where you are not the original 
author must contain its license header with the original author(s) and source.